unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, SzogPont, Grids, CheckLst;

type
  Tmained = class(TForm)
    grafok: TStringGrid;
    ujbutt: TButton;
    modbutt: TButton;
    delbutt: TButton;
    exitbutt: TButton;
    procedure FormCreate(Sender: TObject);
    procedure grafokDblClick(Sender: TObject);
    procedure modbuttClick(Sender: TObject);
    procedure delbuttClick(Sender: TObject);
    procedure ujbuttClick(Sender: TObject);
    procedure savelist;
    procedure exitbuttClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mained: Tmained;

implementation

uses Unit2,ugraf, Unit3;

{$R *.dfm}

procedure Tmained.FormCreate(Sender: TObject);
var f:textfile; n,i:integer; name,fl:string[20]; szpsz,irany,suly,elsz:integer;
begin
  grafok.rows[0].Add('Nv');
  grafok.rows[0].Add('File');
  grafok.rows[0].Add('SzgpontSzm');
  grafok.rows[0].Add('lszm');
  grafok.rows[0].Add('Irnyts');
  grafok.rows[0].Add('Slyzottsg');
  assignfile(f,'grafok.txt');
  reset(f);
  readln(f,n);
  for i:=1 to n do begin
      readln(f,name);
      readln(f,fl);
      readln(f,szpsz);
      readln(f,elsz);
      readln(f,irany);
      readln(f,suly);
      with grafok.rows[grafok.RowCount-1] do begin
        strings[0]:=name;
        strings[1]:=fl;
        strings[2]:=inttostr(szpsz);
        strings[3]:=inttostr(elsz);
        if irany=1 then strings[4]:='Irnytott' else strings[4]:='Irnytatlan';
        if suly=1 then strings[5]:='Slyzott' else strings[5]:='Nem Slyzott';

      end;
      grafok.RowCount:=1+grafok.RowCount;
  end;
  grafok.RowCount:=grafok.RowCount-1;
  closefile(f)

end;

procedure Tmained.grafokDblClick(Sender: TObject);
begin
  modbutt.click;
end;

procedure Tmained.modbuttClick(Sender: TObject);
var i,j,jj:integer;
begin
graff:=TGraf.create;
flnm:=grafok.rows[grafok.Selection.Top].Strings[1];
graff.loadfromfile(flnm);

if graff.szogpontszam =0 then jj:=1 else jj:=graff.szogpontszam;
  edit.matr.RowCount:=jj+1;
  edit.matr.ColCount:=jj+1;
  for i:=1 to jj do begin
    edit.matr.Cells[0,i]:=inttostr(i);
    edit.matr.Cells[i,0]:=inttostr(i)
  end;
  for i:=1 to graff.szogpontszam do
    for j:=1 to graff.szogpontszam do
       edit.matr.Cells[j,i]:=inttostr(graff.adatok[i,j]);

       spkn:=0;
       with graff do begin
         spkn := szogpontszam;

         for i:=1 to szogpontszam do begin
            spk[i]:=Tszogpont.Create(edit);
            spk[i].Parent:=edit;
            spk[i].Caption:=inttostr(i);
            spk[i].Height:=19;
            spk[i].Width:=19;
            spk[i].CX:=koord[i,1];
            spk[i].CY:=koord[i,2];
            spk[i].index:=i;
            spk[i].OnMouseDown:=edit.SzogPont1MouseDown;
            spk[i].OnMouseUp:=edit.SzogPont1Mouseup;
            spk[i].OnMouseMove:=edit.SzogPont1MouseMove;
         end;
       end;


edit.showmodal;
graff.free;
for i:=1 to spkn do spk[i].free;
spkn:=0;
savelist;
end;

procedure Tmained.delbuttClick(Sender: TObject);
var i:integer;
begin
if grafok.RowCount=2 then exit;
Deletefile(grafok.rows[grafok.Selection.Top].Strings[1]);
for i:=grafok.Selection.Top to grafok.RowCount-2 do
    grafok.Rows[i].Assign(grafok.Rows[i+1]);
grafok.RowCount:=grafok.RowCount-1;
savelist;
end;

procedure Tmained.ujbuttClick(Sender: TObject);
var v:tgraf;
begin
   with ujgrf do begin
    namet.Text:='';
    filen.Text:='';
    irany.Checked:=false;
    suly.Checked:=false;
   end;
   if ujgrf.ShowModal = mrok then begin
       v:=Tgraf.Create;
       v.szogpontszam:=1;
       v.adatok[1,1]:=0;
       v.koord[1,1]:=20;
       v.koord[1,2]:=20;
       v.iranyitott:=ujgrf.irany.checked;
       v.sulyozott:=ujgrf.suly.checked;
       v.savetofile(ujgrf.filen.Text);
       v.Free;
       grafok.rowcount:=grafok.rowcount+1;
       with grafok.rows[grafok.RowCount-1] do begin
         strings[0]:=ujgrf.namet.text;
         strings[1]:=ujgrf.filen.Text;
         strings[2]:='1';
         strings[3]:='0';
         if ujgrf.irany.checked then strings[4]:='Irnytott' else strings[4]:='Irnytatlan';
         if ujgrf.suly.checked then strings[5]:='Slyzott' else strings[5]:='Nem Slyzott';
      end;
      savelist;
   end;
end;
procedure Tmained.savelist;
var f:textfile; i:integer;
begin
  assignfile(f,'grafok.txt');
  rewrite(f);
  writeln(f,grafok.rowcount-1);
  for i:=1 to grafok.rowcount-1 do begin
      writeln(f,grafok.rows[i].strings[0]);
      writeln(f,grafok.rows[i].strings[1]);
      writeln(f,grafok.rows[i].strings[2]);
      writeln(f,grafok.rows[i].strings[3]);
      if grafok.rows[i].strings[4]='Irnytott' then writeln(f,1) else writeln(f,0);
      if grafok.rows[i].strings[5]='Slyzott' then writeln(f,1) else writeln(f,0);
  end;
  closefile(f)
end;
procedure Tmained.exitbuttClick(Sender: TObject);
begin
  savelist;
  application.Terminate;
end;

end.

